<script setup lang="ts">
import { reactive, onMounted } from 'vue';
import { PageContainer } from 'antdv-pro-layout';
import { message, Modal } from 'ant-design-vue/es';
import { forceLogout, listOnline } from '@/api/monitor/online';
import { parseDateToStr } from '@/utils/date-utils';
import { SizeType } from 'ant-design-vue/es/config-provider';
import { MenuInfo } from 'ant-design-vue/es/menu/src/interface';
import { ColumnsType } from 'ant-design-vue/es/table';
import { RESULT_CODE_SUCCESS } from '@/constants/result-constants';
import useI18n from '@/hooks/useI18n';
const { t } = useI18n();

/**查询参数 */
let queryParams = reactive({
  /**登录主机 */
  ipaddr: '',
  /**登录账号 */
  userName: '',
});

/**表格状态类型 */
type TabeStateType = {
  /**加载等待 */
  loading: boolean;
  /**紧凑型 */
  size: SizeType;
  /**搜索栏 */
  seached: boolean;
  /**记录数据 */
  data: object[];
};

/**表格状态 */
let tableState: TabeStateType = reactive({
  loading: false,
  size: 'middle',
  seached: false,
  data: [],
});

/**表格字段列 */
let tableColumns: ColumnsType = [
  {
    title: t('common.rowId'),
    dataIndex: 'num',
    width: '50px',
    align: 'left',
    customRender(opt) {
      const idxNum = (tablePagination.current - 1) * tablePagination.pageSize;
      return idxNum + opt.index + 1;
    },
  },
  {
    title: t('views.monitor.online.mettingId'),
    dataIndex: 'tokenId',
    align: 'left',
  },
  {
    title: t('views.monitor.online.account'),
    dataIndex: 'userName',
    align: 'left',
  },
  {
    title: t('views.monitor.online.host'),
    dataIndex: 'ipaddr',
    align: 'left',
  },
  // {
  //   title: t('views.monitor.online.loginDes'),
  //   dataIndex: 'loginLocation',
  //   align: 'center',
  // },
  {
    title: t('views.monitor.online.os'),
    dataIndex: 'os',
    align: 'left',
  },
  {
    title: t('views.monitor.online.lib'),
    dataIndex: 'browser',
    align: 'left',
  },
  {
    title: t('views.monitor.online.loginTime'),
    dataIndex: 'loginTime',
    align: 'left',
    customRender(opt) {
      if (+opt.value <= 0) return '';
      return parseDateToStr(+opt.value);
    },
  },
  {
    title: t('common.operate'),
    key: 'tokenId',
    align: 'left',
  },
];

/**表格分页器参数 */
let tablePagination = {
  /**当前页数 */
  current: 1,
  /**每页条数 */
  pageSize: 20,
  /**默认的每页条数 */
  defaultPageSize: 20,
  /**指定每页可以显示多少条 */
  pageSizeOptions: ['10', '20', '50', '100'],
  /**只有一页时是否隐藏分页器 */
  hideOnSinglePage: true,
  /**是否可以快速跳转至某页 */
  showQuickJumper: true,
  /**是否可以改变 pageSize */
  showSizeChanger: true,
  /**数据总数 */
  total: 0,
  showTotal: (total: number) => t('common.tablePaginationTotal', { total }),
  onChange: (page: number, pageSize: number) => {
    tablePagination.current = page;
    tablePagination.pageSize = pageSize;
  },
};

/**表格紧凑型变更操作 */
function fnTableSize({ key }: MenuInfo) {
  tableState.size = key as SizeType;
}

/**查询参数重置 */
function fnQueryReset() {
  queryParams.ipaddr = '';
  queryParams.userName = '';
  tablePagination.current = 1;
  tablePagination.pageSize = 20;
  fnGetList();
}

/** 查询在线用户列表 */
function fnGetList() {
  if (tableState.loading) return;
  tableState.loading = true;
  listOnline(queryParams).then(res => {
    if (res.code === RESULT_CODE_SUCCESS && Array.isArray(res.rows)) {
      tableState.data = res.rows;
    }
    tableState.loading = false;
  });
}

/** 强退按钮操作 */
function fnForceLogout(row: Record<string, string>) {
  Modal.confirm({
    title: t('common.tipTitle'),
    content: t('views.monitor.online.getOutSure', { userName: row.userName }),
    onOk() {
      const hide = message.loading(t('common.loading'), 0);
      forceLogout(row.tokenId)
        .then(res => {
          if (res.code === RESULT_CODE_SUCCESS) {
            message.success({
              content: t('common.msgSuccess', {
                msg: t('views.monitor.online.getOut'),
              }),
              duration: 3,
            });
          } else {
            message.error({
              content: `${res.msg}`,
              duration: 3,
            });
          }
        })
        .finally(() => {
          hide();
          fnGetList();
        });
    },
  });
}

onMounted(() => {
  fnGetList();
});
</script>

<template>
  <PageContainer>
    <a-card
      v-show="tableState.seached"
      :bordered="false"
      :body-style="{ marginBottom: '24px', paddingBottom: 0 }"
    >
      <!-- 表格搜索栏 -->
      <a-form :model="queryParams" name="queryParams" layout="horizontal">
        <a-row :gutter="16">
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item
              :label="t('views.monitor.online.account')"
              name="userName"
            >
              <a-input
                v-model:value="queryParams.userName"
                allow-clear
                :maxlength="30"
              ></a-input>
            </a-form-item>
          </a-col>
          <a-col :lg="6" :md="12" :xs="24">
            <a-form-item :label="t('views.monitor.online.host')" name="ipaddr">
              <a-input
                v-model:value="queryParams.ipaddr"
                allow-clear
                :maxlength="128"
              >
              </a-input> </a-form-item
          ></a-col>
          <a-col :lg="12" :md="24" :xs="24">
            <a-form-item>
              <a-space :size="8">
                <a-button type="primary" @click.prevent="fnGetList">
                  <template #icon><SearchOutlined /></template>
                  {{ t('common.search') }}
                </a-button>
                <a-button type="default" @click.prevent="fnQueryReset">
                  <template #icon><ClearOutlined /></template>
                  {{ t('common.reset') }}
                </a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
    </a-card>

    <a-card :bordered="false" :body-style="{ padding: '0px' }">
      <!-- 插槽-卡片右侧 -->
      <template #extra>
        <a-space :size="8" align="center">
          <a-tooltip>
            <template #title>{{ t('common.searchBarText') }}</template>
            <a-switch
              v-model:checked="tableState.seached"
              :checked-children="t('common.switch.show')"
              :un-checked-children="t('common.switch.hide')"
              size="small"
            />
          </a-tooltip>
          <a-tooltip>
            <template #title>{{ t('common.reloadText') }}</template>
            <a-button type="text" @click.prevent="fnGetList()">
              <template #icon><ReloadOutlined /></template>
            </a-button>
          </a-tooltip>
          <a-tooltip placement="topRight">
            <template #title>{{ t('common.sizeText') }}</template>
            <a-dropdown placement="bottomRight" trigger="click">
              <a-button type="text">
                <template #icon><ColumnHeightOutlined /></template>
              </a-button>
              <template #overlay>
                <a-menu
                  :selected-keys="[tableState.size as string]"
                  @click="fnTableSize"
                >
                  <a-menu-item key="default">
                    {{ t('common.size.default') }}
                  </a-menu-item>
                  <a-menu-item key="middle">
                    {{ t('common.size.middle') }}
                  </a-menu-item>
                  <a-menu-item key="small">
                    {{ t('common.size.small') }}
                  </a-menu-item>
                </a-menu>
              </template>
            </a-dropdown>
          </a-tooltip>
        </a-space>
      </template>

      <!-- 表格列表 -->
      <a-table
        class="table"
        row-key="tokenId"
        :columns="tableColumns"
        :loading="tableState.loading"
        :data-source="tableState.data"
        :size="tableState.size"
        :pagination="tablePagination"
        :scroll="{ x: true }"
      >
        <template #bodyCell="{ column, record }">
          <template v-if="column.key === 'tokenId'">
            <a-button
              type="link"
              danger
              @click.prevent="fnForceLogout(record)"
              v-perms:has="['monitor:online:forceLogout']"
            >
              <template #icon><LogoutOutlined /></template>
              {{ t('views.monitor.online.getOut') }}
            </a-button>
          </template>
        </template>
      </a-table>
    </a-card>
  </PageContainer>
</template>

<style lang="less" scoped>
.table :deep(.ant-pagination) {
  padding: 0 24px;
}
</style>
